<?php 
defined( 'ABSPATH' ) || exit;

class JLTMA_Megamenu_Cpt{
    
    private static $_instance = null;

    public function __construct() {        
        add_action('init', [$this, 'post_types']);
    }

    public function post_types() {
        
        $labels = array(
            'name'                  => _x( 'Master Addons Items', 'Post Type General Name', 'jltma' ),
            'singular_name'         => _x( 'Master Addons Item', 'Post Type Singular Name', 'jltma' ),
            'menu_name'             => esc_html__( 'Master Addons item', 'jltma' ),
            'name_admin_bar'        => esc_html__( 'Master Addons item', 'jltma' ),
            'archives'              => esc_html__( 'Item Archives', 'jltma' ),
            'attributes'            => esc_html__( 'Item Attributes', 'jltma' ),
            'parent_item_colon'     => esc_html__( 'Parent Item:', 'jltma' ),
            'all_items'             => esc_html__( 'All Items', 'jltma' ),
            'add_new_item'          => esc_html__( 'Add New Item', 'jltma' ),
            'add_new'               => esc_html__( 'Add New', 'jltma' ),
            'new_item'              => esc_html__( 'New Item', 'jltma' ),
            'edit_item'             => esc_html__( 'Edit Item', 'jltma' ),
            'update_item'           => esc_html__( 'Update Item', 'jltma' ),
            'view_item'             => esc_html__( 'View Item', 'jltma' ),
            'view_items'            => esc_html__( 'View Items', 'jltma' ),
            'search_items'          => esc_html__( 'Search Item', 'jltma' ),
            'not_found'             => esc_html__( 'Not found', 'jltma' ),
            'not_found_in_trash'    => esc_html__( 'Not found in Trash', 'jltma' ),
            'featured_image'        => esc_html__( 'Featured Image', 'jltma' ),
            'set_featured_image'    => esc_html__( 'Set featured image', 'jltma' ),
            'remove_featured_image' => esc_html__( 'Remove featured image', 'jltma' ),
            'use_featured_image'    => esc_html__( 'Use as featured image', 'jltma' ),
            'insert_into_item'      => esc_html__( 'Insert into item', 'jltma' ),
            'uploaded_to_this_item' => esc_html__( 'Uploaded to this item', 'jltma' ),
            'items_list'            => esc_html__( 'Items list', 'jltma' ),
            'items_list_navigation' => esc_html__( 'Items list navigation', 'jltma' ),
            'filter_items_list'     => esc_html__( 'Filter items list', 'jltma' ),
        );
        $rewrite = array(
            'slug'                  => 'mastermega-content',
            'with_front'            => true,
            'pages'                 => false,
            'feeds'                 => false,
        );        
        $args = array(
            'label'                 => esc_html__( 'Master Addons Item', 'jltma' ),
            'description'           => esc_html__( 'mastermega_content', 'jltma' ),
            'labels'                => $labels,
            'supports'              => array( 'title', 'editor', 'elementor', 'permalink' ),
            'hierarchical'          => true,
            'public'                => true,
            'show_ui'               => false,
            'show_in_menu'          => false,
            'menu_position'         => 5,
            'show_in_admin_bar'     => false,
            'show_in_nav_menus'     => false,
            'can_export'            => true,
            'has_archive'           => false,
            'publicly_queryable' => true,
            'rewrite'               => $rewrite,
            'query_var' => true,
            'exclude_from_search'   => true,
            'publicly_queryable'    => true,
            'capability_type'       => 'page',
            'show_in_rest'          => true,
            'rest_base'             => 'mastermega-content',
        );
        register_post_type( 'mastermega_content', $args );

    }

    public static function get_instance() {
        if ( is_null( self::$_instance ) ) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

}


/*
* Returns Instanse of the Master Mega Menu
*/
if( !function_exists('jltma_megamenu_cpt')){
    function jltma_megamenu_cpt(){
        return JLTMA_Megamenu_Cpt::get_instance();
    }
}

jltma_megamenu_cpt();